/*

Morse code sound generator

Juha Niinikoski 11.12.2004

Scandi characters & small corrections 12.12.2004
*/


/* Play Characters with Morse code  */

#define UNIT	50		// Morse unit ms
#define DI	UNIT
#define DAA	(3*UNIT)
#define L_SPACE	((3*UNIT) - 1)
#define W_SPACE ((7*UNIT) - 1)

void beep(char n_units)
	{
	LEDC = 1;		// play indicator on
	GIEH = 0;		// set tone
	tone = 0xFFFF - kHz/2;
	GIEH = 1;
	tone_on = 1;		// tone on
	delaym(n_units);		// play
	tone_on = 0;		// tone off
	LEDC = 0;		// play indicator off
	delaym(UNIT);		// wait symbol space
	}

// Decode & play one Morse code character

void morse_chr(char m_code)
	{
	switch (m_code)		// decode available characters
		{
		case 'A': case 'a':
		beep(DI);
		beep(DAA);
		break;

		case 'B': case 'b':
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case 'C': case 'c':
		beep(DAA);
		beep(DI);
		beep(DAA);
		beep(DI);
		break;

		case 'D': case 'd':
		beep(DAA);
		beep(DI);
		beep(DI);
		break;

		case 'E': case 'e':
		beep(DI);
		break;

		case 'F': case 'f':
		beep(DI);
		beep(DI);
		beep(DAA);
		beep(DI);
		break;

		case 'G': case 'g':
		beep(DAA);
		beep(DAA);
		beep(DI);
		break;

		case 'H': case 'h':
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case 'I': case 'i':
		beep(DI);
		beep(DI);
		break;

		case 'J': case 'j':
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		break;

		case 'K': case 'k':
		beep(DAA);
		beep(DI);
		beep(DAA);
		break;

		case 'L': case 'l':
		beep(DI);
		beep(DAA);
		beep(DI);
		beep(DI);
		break;

		case 'M': case 'm':
		beep(DAA);
		beep(DAA);
		break;

		case 'N': case 'n':
		beep(DAA);
		beep(DI);
		break;

		case 'O': case 'o':
		beep(DAA);
		beep(DAA);
		beep(DAA);
		break;

		case 'P': case 'p':
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DI);
		break;

		case 'Q': case 'q':
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DAA);
		break;

		case 'R': case 'r':
		beep(DI);
		beep(DAA);
		beep(DI);
		break;

		case 'S': case 's':
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case 'T': case 't':
		beep(DAA);
		break;

		case 'U': case 'u':
		beep(DI);
		beep(DI);
		beep(DAA);
		break;

		case 'V': case 'v':
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DAA);
		break;

		case 'W': case 'w':
		beep(DI);
		beep(DAA);
		beep(DAA);
		break;

		case 'X': case 'x':
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DAA);
		break;

		case 'Y': case 'y':
		beep(DAA);
		beep(DI);
		beep(DAA);
		beep(DAA);
		break;

		case 'Z': case 'z':
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DAA);
		break;

		case '': case '':
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DAA);
		break;

		case '': case '':
		beep(DI);
		beep(DAA);
		beep(DI);
		beep(DAA);
		break;

		case '': case '':
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DI);
		break;


		case '0':
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		break;

		case '1':
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		break;

		case '2':
		beep(DI);
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		break;

		case '3':
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DAA);
		beep(DAA);
		break;

		case '4':
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DAA);
		break;

		case '5':
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case '6':
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case '7':
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DI);
		break;

		case '8':
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DI);
		break;

		case '9':
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DAA);
		beep(DI);
		break;

		case '.':
		beep(DI);
		beep(DAA);
		beep(DI);
		beep(DAA);
		beep(DI);
		beep(DAA);
		break;

		case ',':
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DI);
		beep(DAA);
		beep(DAA);
		break;

		case '?':
		beep(DI);
		beep(DI);
		beep(DAA);
		beep(DAA);
		beep(DI);
		beep(DI);
		break;

		case ' ':	// word space
		delaym(W_SPACE);
		break;
		}

	delaym(L_SPACE);	// letter space after ewery letter
	}

// Decode & play Morse code character string

void morse_str(register const char *str)
	{
	while((*str)!=0)
		{
		morse_chr(*str);
		str++;
		}
	}


