/*

Simple PC Keyboard receive routine

Juha Niinikoski 10.10.2002

PIC18F452 port 7.12.2004

*/

near unsigned char rxdata, x;					// near variable for speed

/* wait and receive from keyboard */

unsigned char kb_receive()
	{
	tout = 250;						// set timeout for kb read operation
	timeout = 0;
	rxdata = 0;

	while(KBDATA == 1 && timeout == 0);			// wait for start condition
	asm("nop");
	asm("nop");
	while(KBDATA == 1 && timeout == 0);			// filter glitches test

	while(KBCLOCK == 1 && timeout == 0);			// wait clock to drop
	while(KBCLOCK == 0 && timeout == 0);			// wait clock to rise

	for(x=0; x<8; x++)			// loop data bits
		{
		while(KBCLOCK == 1 && timeout == 0);		// wait clock to drop

		rxdata = rxdata >> 1;		// shift previous bit down
		if(KBDATA == 1)			// sample data
			rxdata = rxdata | 0x80;	// = 1
		else
			rxdata = rxdata & 0x7F;	// = 0

		while(KBCLOCK == 0 && timeout == 0);		// wait clock to rise
		}

	while(KBCLOCK == 1 && timeout == 0);			// wait clock to drop and read parity
	kbparity = KBDATA;			// store parity for debug
	while(KBCLOCK == 0 && timeout == 0);			// wait clock to rise

	while(KBCLOCK == 1 && timeout == 0);			// wait clock to drop Stop bit
	while(KBCLOCK == 0 && timeout == 0);			// wait clock to rise

	return rxdata;
	}

