/*

PIC18F452  DIS Ignition board tests

Juha Niinikoski 08.01.2003

Console printouts

*/

/* print all sort of diagnostics information about controller and its parameters */

void diag_print(void)
	{
	IOSW = RS232;
	putst("\n\nDiagnostic printout:");

	putst("\nRPM = ");
	putuintdec(current_rpm);

	putst("\ncycle.t = ");
	putinthex(cycle.t);
	putch(' ');
	putuintdec(cycle.t);

	putst("\ncoil_load.c  = ");
	putuintdec(coil_load.c);

	putst("\ntrigger.c   =  ");
	putuintdec(trigger.c);

	putst("\ndwell   = ");
	putuintdec(dwell);

	putst("\nadvance = ");
	putintdec(adv_input, 1);

	putst("\nbinadv  = ");
	putintdec(binadv, 0);

	putst("\nMAP adv cut in RPM =");
	putintdec(map_cut_in, 0);

	putst("\nMAP adv fully applied RPM =");
	putintdec(map_full_in, 0);

	putst("\nCH0, Pressure =");
	putintdec(current_map, 0);
	putst(" kPa");

	putst("\nCH1, Battery  =");
	putintdec(current_bat, 1);
	putst(" V");

	putst("\nCH3, AUX      =");
	putintdec(convert_adc(3), 0);

	putst("\nAUX DI = ");
	if(current_aux_bit)
		putch('1');
	else
		putch('0');

	putst("\nend.\n");
	}

/* Print diagnostic menu / help info */

void menu_print(void)
	{
	IOSW = RS232;
	putst("\n\nDiag commands:\n");
	putst("p = print diag\n");
	putst("d = diag mode, manual control (press 5 times)\n");
	putst("n = normal mode\n");
	putst("a = set advance\n");
	putst("w = set dwell\n");
	putst("h/? = help\n\n");
	}

	















