/*


PIC18F452 / Music box

Juha Niinikoski 05.12.2004

PC Keyboard I/O test, new play engine 06.12.2004
More OH7SV composing 06.12.2004
PC Keyboard play interface 07.12.2004
New Keyboard interface strategy & more songs 08.12.2004
PORTA init corrected 09.12.2004
Morse code greetings 10.12.2004
Morse code player 11.12.2004
More songs 12.12.2004

*/


//**********************
// Include header files
//**********************

#include	<pic18.h>
#include	<conio.h>
#include	<stdlib.h>
#include 	<stdio.h>
#include	<ctype.h>

//#include	"soitin.h"	// For early prototype board
#include	"soitin2.h"

#include	"always.h"


//****************
// Hello messages
//*****************

const char ver[] = {"\n\n\n Vempun & Visan music box JNi 08.12.2004"};


//******************
// Global variables
//******************

bit tone_on;			// play tone
near int tone;			// tone half cycle period, 0xFFFF-half cycle

bit play_flag;			// playing note

// keyboard

near char	tout;		// Keyboard timeout counter
bit	timeout;		// Keyboard timeout
bit	kbparity;		// kb input parity

near unsigned char key_in_play;	// key code currently in play
#define	END_FLAG 0xF0		// lift key scan code
#define ESC 0x76		// ESC keyboard button


//*****************
// Include C files
//*****************

#include	"notes.h"	// note frequency table
#include	"timing.c"
#include	"serial.h"
#include	"serial.c"
#include	"pc_kb.c"
#include	"notes.c"	// keycode to note converter
#include	"morse.c"	// morse code generator


//******************
// Processor config
//******************

	__CONFIG(1, HS);		// config bits for 18F452 / v8.20
	__CONFIG(2, PWRTEN & WDTDIS);
	__CONFIG(4, LVPDIS);



//#define debug_mode

//******************
// Helpper routines
//******************

/* Play from list */

// ! Warning !  len must be STAGATO + few milliseconds, not shorter

void play_note( unsigned int t, unsigned int len )
	{
	while(play_flag == 1)		// wait previous note done
		;

	play(t, len);			// start palying
	}


void reset_player(void)
	{
	tone_on = 0;
	play_flag = 0;
	}


//*******************************************
// Songs, Arranged by Matti Hohtola OH7SV
//*******************************************

void aakkoset(void)
	{
	reset_player();

	play_note( C, 500 );
	play_note( C, 500 );
	play_note( G, 500 );
	play_note( G, 500 );
	play_note( A, 500 );
	play_note( A, 500 );
	play_note( G, 1000 );
	play_note( F, 500 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( E, 500 );
	play_note( D, 500 );
	play_note( D, 500 );
	play_note( C, 1000 );
	play_note( G, 500 );
	play_note( G, 500 );
	play_note( F, 500 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( E, 500 );
	play_note( D, 500 );
	play_note( D, 500 );
	play_note( G, 500 );
	play_note( G, 500 );
	play_note( F, 500 );				
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( E, 500 );
	play_note( D, 500 );
	play_note( D, 500 );
	play_note( C, 500 );
	play_note( C, 500 );
	play_note( G, 500 );
	play_note( G, 500 );
	play_note( A, 500 );
	play_note( A, 500 );
	play_note( G, 1000 );
	play_note( F, 500 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( E, 500 );
	play_note( D, 500 );
	play_note( D, 500 );
	play_note( C, 1000 );
	}


void sylvian_joulu(void)
	{
	reset_player();

	play_note( E, 500 );
	play_note( E, 1000 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( c, 1000 );
	play_note( H, 500 );
	play_note( A, 500 );
	play_note( H, 1000 );
	play_note( c, 500 );
	play_note( H, 500 );
	play_note( A, 1000 );
	play_note( G, 500 );
	play_note( F, 500 );
	play_note( E, 1000 );
	play_note( E, 500 );
	play_note( E, 500 );
	play_note( D, 1000 );
	play_note( C, 500 );
	play_note( D, 500 );
	play_note( E, 3000 );
	play_note( pause, 500 );
	play_note( E, 500 );

	play_note( E, 1000 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( c, 1000 );
	play_note( H, 500 );
	play_note( c, 500 );
	play_note( d, 1000 );
	play_note( c, 500 );
	play_note( d, 500 );
	play_note( e, 1500 );
	play_note( e, 500 );
	play_note( d, 1000 );
	play_note( A, 500 );
	play_note( c, 500 );
	play_note( H, 1000 );
	play_note( A, 500 );
	play_note( H, 500 );
	play_note( c, 3000 );
	play_note( pause, 500 );
	play_note( e, 500 );

	play_note( e, 1000 );
	play_note( H, 500 );
	play_note( e, 500 );
	play_note( c, 1000 );
	play_note( H, 500 );
	play_note( c, 500 );
	play_note( d, 1000 );
	play_note( A, 500 );
	play_note( d, 500 );
	play_note( H, 1000 );
	play_note( pause, 500 );
	play_note( H, 500 );
	play_note( c, 1000 );
	play_note( G, 500 );
	play_note( c, 500 );
	play_note( A, 1000 );
	play_note( A, 500 );
	play_note( A, 500 );
	play_note( A, 1000 );
	play_note( G1, 500 );
	play_note( A, 500 );
	play_note( H, 1500 );
	play_note( E, 500 );

	play_note( E, 1000 );
	play_note( F, 500 );
	play_note( E, 500 );
	play_note( c, 1000 );
	play_note( H, 500 );
	play_note( A, 500 );
	play_note( H, 1000 );
	play_note( F1, 500 );
	play_note( G1, 500 );
	play_note( A, 1500 );
	play_note( A, 500 );
	play_note( H, 1000 );
	play_note( A, 500 );
	play_note( H, 500 );
	play_note( c, 1000 );
	play_note( H, 500 );
	play_note( A, 500 );
	play_note( e, 1000 );
	play_note( H, 500 );
	play_note( c, 500 );
	play_note( A, 2000 );
	}

#if 0
// Test, Parempi Sylvia

void test_song(void)
	{
	reset_player();

	play_note( E, 400 );
	play_note( E, 1200 );
	play_note( F, 800 );
	play_note( E, 400 );
	play_note( c, 1200 );
	play_note( H, 800 );
	play_note( A, 400 );
	play_note( H, 1200 );
	play_note( c, 800 );
	play_note( H, 400 );
	play_note( A, 1200 );
	play_note( G, 800 );
	play_note( F, 400 );
	play_note( E, 1200 );
	play_note( E, 1200 );
//
	play_note( D, 1200 );
	play_note( C, 800 );
	play_note( D, 400 );
	play_note( E, 1600 );
	play_note( pause, 1600 );
	play_note( E, 400 );
	play_note( E, 1200 );
	play_note( F, 800 );
	play_note( E, 400 );

	play_note( pause, 500 );
	play_note( kHz, 200 );		// len - stagato = 100
	play_note( kHz, 200 );
	play_note( kHz, 200 );
	}
#endif


// Joulupukki matkaan jo ky

void pukki(void)
	{
	reset_player();

	play_note( F, 400 );		// aloitus

	play_note( D, 200 );		// 1. & 2. sKEEN ALKU
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );

	play_note( C, 400 );
	play_note( D1, 800 );
	play_note( AA, 400 );

	play_note( AA1, 1600 );

	play_note( AA1, 800 );
	play_note( pause, 400 );
	play_note( F, 400 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );

	play_note( C, 400 );
	play_note( D1, 800 );
	play_note( AA, 400 );

	play_note( AA1, 800 );
	play_note( G, 400 );
	play_note( AA1, 400 );

	play_note( pause, 1200 );
	play_note( A1, 400 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( A1, 400 );

	play_note( G, 400 );
	play_note( G, 800 );
	play_note( A1, 400 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( A1, 400 );

	play_note( G, 1200 );
	play_note( c, 400 );

	play_note( d, 400 );
	play_note( c, 400 );
	play_note( H, 400 );
	play_note( c, 400 );

	play_note( A, 400 );
	play_note( A, 400 );
	play_note( A, 400 );
	play_note( A, 200 );
	play_note( A1, 200 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( G, 400 );

	play_note( F, 400 );
	play_note( F, 800 );
	play_note( F, 400 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );
//
	play_note( C, 400 );		// 1. skeen loppu
	play_note( D1, 800 );
	play_note( AA, 400 );

	play_note( AA1, 800 );
	play_note( F, 400 );
	play_note( A1, 400 );

	play_note( pause, 1200 );
	play_note( F, 400 );
//_________________________________
	play_note( D, 200 );		// 1. & 2. sKEEN ALKU
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );

	play_note( C, 400 );
	play_note( D1, 800 );
	play_note( AA, 400 );

	play_note( AA1, 1600 );

	play_note( AA1, 800 );
	play_note( pause, 400 );
	play_note( F, 400 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );

	play_note( C, 400 );
	play_note( D1, 800 );
	play_note( AA, 400 );

	play_note( AA1, 800 );
	play_note( G, 400 );
	play_note( AA1, 400 );

	play_note( pause, 1200 );
	play_note( A1, 400 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( A1, 400 );

	play_note( G, 400 );
	play_note( G, 800 );
	play_note( A1, 400 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( A1, 400 );

	play_note( G, 1200 );
	play_note( c, 400 );

	play_note( d, 400 );
	play_note( c, 400 );
	play_note( H, 400 );
	play_note( c, 400 );

	play_note( A, 400 );
	play_note( A, 400 );
	play_note( A, 400 );
	play_note( A, 200 );
	play_note( A1, 200 );

	play_note( c, 400 );
	play_note( A1, 400 );
	play_note( A, 400 );
	play_note( G, 400 );

	play_note( F, 400 );
	play_note( F, 800 );
	play_note( F, 400 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 600 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( A, 200 );
	play_note( A1, 400 );
	play_note( A1, 800 );

	play_note( D, 200 );
	play_note( D1, 200 );
	play_note( F, 400 );
	play_note( F, 400 );
	play_note( F, 400 );

	play_note( G, 200 );
	play_note( F, 200 );
	play_note( D1, 400 );
	play_note( D1, 800 );

	play_note( D, 400 );
	play_note( F, 400 );
	play_note( AA1, 400 );
	play_note( D, 400 );
//
	play_note( C, 400 );		// 2. skeen loppu
	play_note( D1, 800 );
	play_note( c, 400 );
	play_note( A1, 2000 );
	play_note( f, 600 );
	play_note( a1, 600 );
	}


// Hamahakki

void hamahakki(void)
	{
	reset_player();

	play_note( C, 200 );
	play_note( C, 200 );
	play_note( C, 200 );
	play_note( D, 200 );

	play_note( E, 200 );
	play_note( pause, 200 );
	play_note( E, 200 );
	play_note( pause, 200 );

	play_note( D, 200 );
	play_note( C, 200 );
	play_note( D, 200 );
	play_note( E, 200 );

	play_note( C, 400 );
	play_note( pause, 400 );

	play_note( E, 200 );
	play_note( E, 200 );
	play_note( E, 200 );
	play_note( F, 200 );

	play_note( G, 200 );
	play_note( pause, 200 );
	play_note( G, 200 );
	play_note( pause, 200 );

	play_note( F, 200 );
	play_note( E, 200 );
	play_note( F, 200 );
	play_note( G, 200 );

	play_note( E, 400 );
	play_note( pause, 400 );

	play_note( c, 400 );
	play_note( c, 200 );
	play_note( c, 200 );

	play_note( H, 400 );
	play_note( H, 200 );
	play_note( pause, 200 );

	play_note( A, 200 );
	play_note( A, 200 );
	play_note( A, 200 );
	play_note( A, 200 );

	play_note( G, 200 );
	play_note( pause, 600 );

	play_note( C, 200 );
	play_note( C, 200 );
	play_note( C, 200 );
	play_note( D, 200 );

	play_note( E, 200 );
	play_note( pause, 200 );
	play_note( E, 200 );
	play_note( pause, 200 );

	play_note( D, 200 );
	play_note( C, 200 );
	play_note( D, 200 );
	play_note( E, 200 );

	play_note( C, 200 );
	play_note( pause, 600 );
	}

// Tipe-tipe tip tap

void tip_tap(void)
	{
	reset_player();

	play_note( c, 400 );
	play_note( G, 200 );
	play_note( pause, 200 );
	play_note( c, 400 );
	play_note( G, 400 );

	play_note( c, 200 );
	play_note( H, 200 );
	play_note( c, 200 );
	play_note( d, 200 );
	play_note( e, 200 );
	play_note( pause, 200 );
	play_note( c, 400 );

	play_note( g, 800 );
	play_note( f, 800 );

	play_note( e, 800 );
	play_note( d, 600 );
	play_note( pause, 200 );

	play_note( d, 400 );
	play_note( A, 200 );
	play_note( pause, 200 );
	play_note( d, 400 );
	play_note( A, 200 );
	play_note( pause, 200 );

	play_note( d, 200 );
	play_note( c1, 200 );
	play_note( d, 200 );
	play_note( e, 200 );
	play_note( f, 200 );
	play_note( pause, 200 );
	play_note( d, 400 );

	play_note( a, 800 );
	play_note( g, 800 );

	play_note( f, 800 );
	play_note( e, 400 );
	play_note( pause, 400 );

	play_note( c, 200 );
	play_note( pause, 200 );
	play_note( G, 200 );
	play_note( pause, 200 );
	play_note( c, 200 );
	play_note( pause, 200 );
	play_note( G, 200 );
	play_note( pause, 200 );

	play_note( c, 200 );
	play_note( H, 200 );
	play_note( c, 200 );
	play_note( d, 200 );
	play_note( e, 200 );
	play_note( pause, 200 );
	play_note( c, 200 );
	play_note( pause, 200 );

	play_note( g, 200 );
	play_note( pause, 600 );
	play_note( g, 200 );
	play_note( pause, 600 );

	play_note( c, 200 );
	}

//________________________________________

/* KB play */

void kb_play( void )
	{
	unsigned char tmp, tmp2;
	unsigned int decoded_note;

	KBCLOCKT = 1;							// enable kb transmitter
	asm("nop");
	asm("nop");							// let open collector bus rise
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");

// 8.12.2004 logic

	if(KBDATA == 0)							// something from kb waiting		
		{
		tmp = kb_receive();

// soft reset
		if(tmp == ESC)						// soft reset play system?
			{
			KBCLOCKT = 0;					// halt kb transmitter and continue processing
			stop_play();					// stop play
			key_in_play = 0;				// no key in play
#ifdef debug_mode
			putst("\nESC");
#endif
			return;						// reset done
			}

// key lift
		if(tmp == END_FLAG)					// key lift = end play
			{
			tmp2 = kb_receive();				// (wait) & read key code after lift code
			KBCLOCKT = 0;					// halt kb transmitter and start processing
#ifdef debug_mode
			putst("\nkb =");
			putchhex(tmp);
			putst(", ");
			putchhex(tmp2);
#endif
			if(tmp2 == key_in_play)				// lifted key playing ?
				{
				stop_play();				// stop play
				key_in_play = 0;			// no key in play
#ifdef debug_mode
				putst("\nStop");
#endif
				return;					// do nothing
				}
			}


// decode function keys F1, F2 ....
// kb active while playing, possible lift codes etc are trashed

		if(tmp == 0x05)						// F1
			aakkoset();

		if(tmp == 0x06)						// F2
			sylvian_joulu();

		if(tmp == 0x04)						// F3
			pukki();

		if(tmp == 0x0C)						// F4
			tip_tap();



		if(tmp == 0x03)						// F5
			hamahakki();

		if(tmp == 0x0B)						// F6
			morse_str("?");

		if(tmp == 0x83)						// F7
			morse_str("?");

		if(tmp == 0x0A)						// F8
			morse_str("Hyv Joulua Kaikille");


		if(tmp == 0x01)						// F9
			morse_str("Venla");

		if(tmp == 0x09)						// F10
			morse_str("Visa");

		if(tmp == 0x78)						// F11
			morse_str("Kappaleet sovittanut OH7SV");

		if(tmp == 0x07)						// F12
			morse_str("OH2NLT soittorasia 11.12.2004 QRV");

		KBCLOCKT = 0;						// halt kb transmitter and start processing

// decode note
		decoded_note = key_to_note(tmp);			// decode kb scan code
		if(decoded_note != 0)					// match found, put to play
			{
			play(decoded_note, 0);				// start palying forever
			key_in_play = tmp;				// save playing key
#ifdef debug_mode
			putst("\nnote =");
			putuintdec(decoded_note);
#endif
			}

		}

	}


//*****************
// Main function
//*****************

void main(void)
{
char input;
int apu;
char tmp; 


/* Init IO Ports & software modules */


//Set up  PORTA
	PORTA = PORTA_INIT;		// Init Port A
	ADCON1 = ADCON1_INIT;		// Switch = digital I/O
	TRISA = TRISA_INIT;

// Set up PORTB
	PORTB = PORTB_INIT;		// Init Port B
	TRISB = TRISB_INIT;

// Set up PORTC
	PORTC = PORTC_INIT;		// Init Port C
	TRISC = TRISC_INIT;

// Set up PORTD
	PORTD = PORTD_INIT;		// Init Port D
	TRISD = TRISD_INIT;

// Set up PORTE
	PORTE = PORTE_INIT;		// Init POTR E
	TRISE = TRISE_INIT;

	LEDA = 1;			// Run LED ON
	LEDB = 0;			// Irq  = 0
	LEDC = 0;			// Play = 0

	KBDATAT	 = 1;			// tri state kb data line
	KBCLOCKT = 1;			// tri state kb clock line

	serial_setup();			// Init UART
	CTS = 0;

	Init_timers();			// Init timers & interrupt system

	putst("\n\n\n Vempun ja Visan Soittorasia. Juha-set 10.12.2004");	// print version

//	play( kHz, 1000 );		// start Beep
	morse_str("Soittorasia QRV");	// play greetings

	KBCLOCKT = 0;			// halt kb transmitter

	for(;;)				// main for ever loop
	{

	if(SW1 == 0)
		aakkoset();		// play Aakkoset

	if(SW2 == 0)
		hamahakki();		// play Hmhkki

	if(SW3 == 0)
		morse_str("Ovikello soi");	// Morse ovikello 

	kb_play();			// read & decode keyboard

	if (keypressed() == 1)
		{
		switch (getch())
			{

#ifdef debug_mode
			case 'C':				// direct test
				putst("\nC =");
				putuintdec( C );
				tone = 0xFFFF - C/2;
				tone_on = 1;
				break;

			case 'D':
				putst("\nD =");
				putuintdec( D );
				tone = 0xFFFF - D/2;
				tone_on = 1;
				break;

			case 'E':
				putst("\nE =");
				putuintdec( E );
				tone = 0xFFFF - E/2;
				tone_on = 1;
				break;

			case 'F':
				putst("\nF =");
				putuintdec( F );
				tone = 0xFFFF - F/2;
				tone_on = 1;
				break;

			case 'G':
				putst("\nG =");
				putuintdec( G );
				tone = 0xFFFF - G/2;
				tone_on = 1;
				break;

			case 'A':
				putst("\nA =");
				putuintdec( A );
				tone = 0xFFFF - A/2;
				tone_on = 1;
				break;

			case 'H':
				putst("\nH =");
				putuintdec( H );
				tone = 0xFFFF - H/2;
				tone_on = 1;
				break;

			case 'c':
				putst("\nc =");
				putuintdec( c );
				tone = 0xFFFF - c/2;
				tone_on = 1;
				break;

			case 'd':
				putst("\nd =");
				putuintdec( d );
				tone = 0xFFFF - d/2;
				tone_on = 1;
				break;

			case 'e':
				putst("\ne =");
				putuintdec( e );
				tone = 0xFFFF - e/2;
				tone_on = 1;
				break;

			case 'f':
				putst("\nf =");
				putuintdec( f );
				tone = 0xFFFF - f/2;
				tone_on = 1;
				break;

			case 'g':
				putst("\ng =");
				putuintdec( g );
				tone = 0xFFFF - g/2;
				tone_on = 1;
				break;

			case 'a':
				putst("\na =");
				putuintdec( a );
				tone = 0xFFFF - a/2;
				tone_on = 1;
				break;

			case 'h':
				putst("\nh =");
				putuintdec( h );
				tone = 0xFFFF - h/2;
				tone_on = 1;
				break;


			case '2':
				putst("\nc2 =");
				putuintdec( c2 );
				tone = 0xFFFF - c2/2;
				tone_on = 1;
				break;
#endif

			case 'w':
				putst("\nAakkoset nyt opin nin");	// koesoitto aakkoset
				aakkoset();
				break;

			case 's':
				putst("\nSylvian joulu");		// koesoitto joutui joulu
				sylvian_joulu();
				break;

			case 'k':
				putst("\nKeyboard RX test");		// kb test, show KB codes
				KBCLOCKT = 1;				// enable kb
				while(keypressed() == 0)
					{
					if(KBDATA == 0)			// something from kb
						{
						tmp = kb_receive();
						KBCLOCKT = 0;			// halt kb transmitter
						putchhex(tmp);			// display what we got
						putst(" received from keyboard\n");
						KBCLOCKT = 1;			// release kb transmitter
						}
					}
				break;

			case 'm':
				putst("\nGenerate Morse code");		// Morse writer
				for(;;)
					{
					if(keypressed() == 0)
						{
						tmp = getch();
						if(tmp == 0x1B)		// ESC = test break
							{
							break;
							}	
						else
							{
							putch(tmp);	// echo
							morse_chr(tmp);	// generate Morse code
							}
						}
					}
				break;

			case ' ':
				putst("\nTone off");
				tone_on = 0;
				break;

			default:
			putch('?');				// wrong command
			}

		}
	}


}

