/*
 *	Header file 18F452 / Soitin Test, WWW board hardware
 *
 *	Other definitions from Microchip 18F452.h file
 *
 *	Juha Niinikoski 06.12.2004
 *
 */

#define XTAL 	20000000 // CPU clock, Hz
#define	PIC_CLK 20000000 //change this to 3.6864, 4, 16 or 20MHz
                         //this affects  for USART speed, and delays

/*	Port A signals	*/

#define PORTA_INIT	0b00000000	/* PORTB init data */
#define	TRISA_INIT	0b11100011	/* all inputs for AD use */

#define LEDA		LATA4		/* LEDA */
#define LEDB		LATA3		/* LEDB */
#define LEDC		LATA2		/* LEDB */

/*	Port B signals	*/


#define PORTB_INIT	0b00000000	/* PORTB init data */
#define TRISB_INIT	0b11111111

#define BUTTON		RB5		/* Push Button */

#define	KBDATA		RB7		// Keyboard side data line input
#define	KBDATAT		TRISB7		// Keyboard side data tristate control
#define	KBCLOCK		RB6		// Keyboard side clock line
#define	KBCLOCKT	TRISB6		// Keyboard side clock tristate control


/*	Port C signals	*/

/* RC6 - RC7 are reserved for serial IO */

#define PORTC_INIT	0b00000000	/* PORTC init data */
#define TRISC_INIT	0b10011100

#define TONE		RC1		/* Tone output */

#define	CTS		RC5		/* RS232 flow control */

/*	Port D signals	*/

#define PORTD_INIT	0b00000000	/* */
#define TRISD_INIT	0b11111111	/* */


/*	Port E signals	*/

/* Port E used for LED output */


#define PORTE_INIT	0b00000000	/* */
#define TRISE_INIT	0b11111111	/* */


/*   Define unsigned data types   */

#ifndef _BYTE_DEFINED_
#define _BYTE_DEFINED_

typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long LWORD;

#endif


/*   Define Boolean data type   */

#ifndef _BOOL_DEFINED_
#define _BOOL_DEFINED_

typedef BYTE BOOL;

#define FALSE 0
#define TRUE 1

#endif

/*   Define null pointer   */

#ifndef NULL
#define NULL (void *)0
#endif


