/*
 *	Header file 18F452 / Music Box Board Hardware Definitions
 *
 *	Other definitions from Microchip 18F452.h file
 *
 *	Juha Niinikoski 08.12.2004
 *
 */

#define XTAL 	20000000 // CPU clock, Hz
#define	PIC_CLK 20000000 //change this to 3.6864, 4, 16 or 20MHz
                         //this affects  for USART speed, and delays


/*	Port A signals	*/

#define PORTA_INIT	0b00000000	/* PORTB init data */
#define	TRISA_INIT	0b00000111	/* RA0 - RA3 Switch inputs */
#define	ADCON1_INIT	0x07		/* PORTA = Digital I/O */

#define BUTTON		RA0		/* Push Button */

#define SW1		RA0		/* Switch 1 */
#define SW2		RA1		/* Switch 1 */
#define SW3		RA2		/* Switch 1 */


/*	Port B signals	*/

#define PORTB_INIT	0b00000000	/* PORTB init data, Keyboard lines must be 0 */
#define TRISB_INIT	0b11000000	/* Keyboard Interface */

#define	KBDATA		RB6		// Keyboard side data line input
#define	KBDATAT		TRISB6		// Keyboard side data tristate control
#define	KBCLOCK		RB7		// Keyboard side clock line
#define	KBCLOCKT	TRISB7		// Keyboard side clock tristate control


/*	Port C signals	*/

/* RC6 - RC7 are reserved for serial IO */

#define PORTC_INIT	0b00000000	/* PORTC init data */
#define TRISC_INIT	0b10000000

#define LEDA		LATC4		/* LEDA, Green */

#define	CTS		LATC5		/* RS232 flow control */


/*	Port D signals	*/

#define PORTD_INIT	0b00000000	/* PORTD init data */
#define TRISD_INIT	0b00000000	/* All outputs */

#define TONE		LATD0		/* Tone output */

#define LEDB		LATD3		/* LEDB, Yellow */
#define LEDC		LATD2		/* LEDB, Red */


/*	Port E signals	*/

/* Port E used for LED output */

#define PORTE_INIT	0b00000000	/* Empty, all Outputs*/
#define TRISE_INIT	0b00000000	/* */


/*   Define unsigned data types   */

#ifndef _BYTE_DEFINED_
#define _BYTE_DEFINED_

typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long LWORD;

#endif


/*   Define Boolean data type   */

#ifndef _BOOL_DEFINED_
#define _BOOL_DEFINED_

typedef BYTE BOOL;

#define FALSE 0
#define TRUE 1

#endif

/*   Define null pointer   */

#ifndef NULL
#define NULL (void *)0
#endif


